/****************************
CrushFTP GUI Plugin custom js
*****************************/
/* Do not change these lines */
var pluginCrushLDAPGroup = {};
pluginCrushLDAPGroup.localization = {};
/****************************/

// Plugin details
var pluginName = "CrushLDAPGroup";
var _plugin = $("#pnlPlugin" + pluginName);

// Localizations
pluginCrushLDAPGroup.localization = {
	lblEnabledText : "Enabled",
	lblDebugText : "Debug",
	lblJavaRequiredNoteText : " This plugin requires Java 1.5 or higher to function. ",
	lblVersionText : "Version :",
	lblAllowedServerPortText : "Allowed Server Port : ",
	lblLDAPCacheTimeText : "LDAP Cache Time : ",
	lblUsernameForQueriesText : "Username For Queries : ",
	lblPasswordText : "Password : ",
	lblLDAPServerURLText : "LDAP Server URL : ",
	btnTestLoginSettingsText : "Test Connection Settings",
	lblSearchBaseLocationText : "Search Base Location : ",
	lblSearchFilterText : "Search Filter : ",
	btnTestSearchText : "Test Search",
	lblSearchNoteText : " Tree will be searched for a field that matches the username. In general this will be 'uid' or 'sAMAccountName'. ",
	lblLDAPRolesTheUserMustBeMemberOfText : "LDAP roles the user must be a member of : ",
	lblLeaveBlankForAllUsersNoteText : " Leave blank for all users. ",
	btnTestSearchRoleText : "Test Search Role",
	lblRoleMemberFieldText : "Role Member Field : ",
	lblRoleMemberFieldNoteText : " (memberOf, memberof, member, groupMembership, memberUid, memberuid, etc.) ",
	lblLDAPOnlyUsedForAuthenticationText : "LDAP only used for Authentication (User manager then defines user's access.)",
	lblHomeDirectoryFieldText : "HomeDirectory field : ",
	lblPrivsText : "Privs : ",
	lblHomeFolderNoteText : " (This field will be used for the users 'home' folder. If not found... see below.) ",
	lblCreateHomedirectoryIfNotExistText : "Create HomeDirectory folder if it doesn't exist.",
	lblUseLocalFolderText : "Use local folder if LDAP's HomeDirectory not found?",
	lblAppendUsernameToPathText : "Append username to path?",
	lblCreateFolderWithUsernameText : "Create folder with username",
	lblPathText : "Path: ",
	lblImportSettingsText : "Import settings from CrushFTP user : ",
	lblOverwriteVFSItemsText : "Overwrite VFS items?"
};

// Assign localizations
localizations.panels["Plugins"][pluginName] = $.extend(pluginCrushLDAPGroup.localization, localizations.panels["Plugins"][pluginName]);

// Interface methods
pluginCrushLDAPGroup.init = function(pluginID, returnXML){
	pluginCrushLDAPGroup.returnXML = returnXML;
	applyLocalizations(pluginName, localizations.panels["Plugins"]);
	pluginCrushLDAPGroup.bindData(0, pluginID);
}

pluginCrushLDAPGroup.bindData = function(index, pluginID)
{
	index = index || 0;
	var pluginPrefs = [];
	pluginCrushLDAPGroup.showServerList();
	if(pluginID)
	{
		var data = $(document).data("PluginBindData" + pluginID);
		pluginPrefs = data.dataItem;
		$(".nonEmbed", _plugin).hide();
	}
	else
	{
		pluginPrefs = common.data.getPluginPrefs(pluginName);
	}
	if(pluginPrefs)
	{
		var curPlugin = pluginPrefs;
		if(!pluginID && pluginPrefs.length)
		{
			curPlugin = pluginPrefs[index];
		}
		pluginCrushLDAPGroup.bindPluginDetails(curPlugin);
	}
	pluginCrushLDAPGroup.loadedSubItem = index;
	pluginCrushLDAPGroup.bindEvents(index);
}

pluginCrushLDAPGroup.bindEvents = function()
{
	if(this.eventAdded)return;
	_plugin.find("input, select, textarea").bind("change", function(){
		panelPlugins.itemsChanged(true, pluginCrushLDAPGroup.returnXML, pluginName);
	});

	_plugin.find("input[type='text'], textarea").bind("textchange", function(){
		panelPlugins.itemsChanged(true, pluginCrushLDAPGroup.returnXML, pluginName);
	});


	$("a#testLogin, a#testSearch, a#testSearchRole", _plugin).click(function(){
		var link = $(this);
		if(link.attr("disabled")) return false;
		pluginCrushLDAPGroup.saveContent(false, false, false, function(flag){
			if(flag)
			{
				var title = "";
				var obj = {
					command : "pluginMethodCall",
					method : link.attr("id"),
					pluginName : "CrushLDAPGroup",
					pluginSubItem : pluginCrushLDAPGroup.loadedSubItem == 0 ? "" : _plugin.attr("subPluginName"),
					username : $("#adminUsername", _panel).val()
				}
				if(obj.method == "testLogin")
				{
					obj.password = common.methods.htmlEncode($("#adminPassword", _panel).val());
					title = "Testing Login";
				}
				else if(obj.method == "testSearch")
				{
					title = "Testing Search";
				}
				else if(obj.method == "testSearchRole")
				{
					title = "Testing Search Role";
				}
				function initCall()
				{
					link.block({
						message:  'Wait..',
						css: {
							border: 'none',
							padding: '0px 10px',
							backgroundColor: '#000',
							'-webkit-border-radius': '10px',
							'-moz-border-radius': '10px',
							opacity: .5,
							color: '#fff',
							'text-align':'left'
						}
					}).attr("disabled", "disabled");

					common.data.serverRequest(obj, function(msg){
						link.unblock().removeAttr("disabled");
						growl(title, decodeURIComponent($(msg).text()), false, false);
					});
				}
				if(obj.method == "testSearch"  || obj.method == "testSearchRole")
				{
					jPrompt("Enter test username:", "", "Test Search", function(val){
						if(val)
						{
							obj.username = val;
							initCall();
						}
					});
				}
				else
				{
					initCall();
				}
			}
		}, true);
		return false;
	});

	$("a.serverFilePickButton", _plugin).each(function(){
		$(this).click(function(){
			var curElem = $(this);
			curElem.crushFtpVFSBrowserPopup({
				type : curElem.attr("PickType") || 'dir',
				callback : function(selectedPath){
					$("#" + curElem.attr("rel"), _plugin).val(selectedPath).trigger("change");
				}
			});
			return false;
		});
	});

	this.eventAdded = true;
}

pluginCrushLDAPGroup.bindPluginDetails = function(controlData)
{
	var inputs = _plugin.find("input.ignoreBind,select.ignoreBind,textarea.ignoreBind").removeClass("ignoreBind");
	bindValuesFromXML(_plugin, controlData);
	if(controlData.subItem && controlData.subItem.length>0)
		_plugin.attr("subPluginName", controlData.subItem[0].text || false);
	inputs.addClass("ignoreBind");
}

pluginCrushLDAPGroup.showServerList = function()
{
	if(!this.serverListShown)
	{
		var service = common;
		if(pluginCrushLDAPGroup.returnXML)
		{
			service = userManager;
		}
		var serverList = service.data.getSubValueFromPrefs("server_list");
		var serverPorts = $("#server_item", _plugin);
		for(var i=0;i<serverList.length;i++)
		{
			var curItem = serverList[i];
			if(curItem)
			{
				var serverType = service.data.getTextContentFromPrefs(curItem, "serverType");
				var ip = service.data.getTextContentFromPrefs(curItem, "ip");
				var port = service.data.getTextContentFromPrefs(curItem, "port");
				var server = ip + "_" + port;
				var newControl = $("<option>"+server+"</option>");
				serverPorts.append(newControl);
				newControl.data("controlData", curItem);
			}
		}
		serverPorts.prepend("<option>All</option>");
		this.serverListShown = true;
	}
}

pluginCrushLDAPGroup.saveContent = function(saveByIndex, cloneName, removeByIndex, callback, noGrowl)
{
	removeByIndex = removeByIndex || 0;
	if(pluginPlaceHolder.data("hasChanged") || removeByIndex>0 || (saveByIndex>0 && cloneName) || pluginCrushLDAPGroup.returnXML)
	{
		if(!pluginCrushLDAPGroup.returnXML)
			common.UI.showIndicator(false, false, "Please wait..");
		var xmlString = [];
		var container = _plugin;
		if(removeByIndex == 0)
		{
			xmlString.push("<plugins_subitem type=\"properties\">");
			xmlString.push("<version>"+$("#version", _plugin).text()+"</version>");
			xmlString.push("<pluginName>"+pluginName+"</pluginName>");
			xmlString.push(buildXMLToSubmitForm(_plugin, true));
			if(saveByIndex)
			{
				xmlString.push("<subItem>"+common.methods.htmlEncode(cloneName)+"</subItem>");
			}
			else
			{
				if(container.attr("subPluginName") && this.subItem>0)
				{
					xmlString.push("<subItem>"+common.methods.htmlEncode(container.attr("subPluginName"))+"</subItem>");
				}
				else
				{
					xmlString.push("<subItem></subItem>");
				}
			}
			xmlString.push("</plugins_subitem>");
		}
		var formSubItem = xmlString.join("\n");

		if(pluginCrushLDAPGroup.returnXML)
			return formSubItem;

		var action = removeByIndex == 0 ? "change" : "remove";
		var index = window.currentPluginIndex;
		var subItemIndex = removeByIndex == 0 ? saveByIndex || this.subItem : removeByIndex;
		subItemIndex = subItemIndex || 0;
		var removeChangeFlag = (saveByIndex>0 && cloneName);
		panelPlugins.savePluginContentProcess(action, formSubItem, index, subItemIndex, removeChangeFlag, callback, noGrowl);
	}
	else
	{
		if(!noGrowl)
			growl("No changes made", "", false, 3000);
		else
			callback(true);
	}
}