/****************************
CrushFTP GUI Panel custom js
*****************************/
/* Do not change these lines */
var panelEvents = {};
panelEvents.localization = {};
/****************************/

// Panel details
var panelName = "Events";
panelEvents._panel = $("#pnl" + panelName);
var pluginPlaceHolder = $("#pluginPlaceHolder", panelEvents._panel);
var eventList = $("#eventList", panelEvents._panel);
var event_action_list = $("#event_action_list", panelEvents._panel);

// Localizations
panelEvents.localization = {
};

// Assign localizations
localizations.panels[panelName] = $.extend(panelEvents.localization, localizations.panels[panelName]);

// Interface methods
panelEvents.init = function(){
	applyLocalizations(panelName, localizations.panels);
	window.dataBindEvents.push(panelEvents.bindData);
	panelEvents.bindEvents();
}

panelEvents.clearForm = function(panel)
{
	panel = panel || panelEvents._panel;
	panel.find("input, select, textarea").each(function(){
		if($(this).attr("type")=="checkbox")
		{
			if($(this).closest("td").is(".checkboxArea"))return;
			userManager.UI.checkUnchekInput($(this));
		}
		else
		{
			$(this).val("");
		}
	});
}

panelEvents.bindData = function(userInfo, jsonDeep, panel, ignoreBind)
{
	if(!ignoreBind)
	{
		panelEvents.jsonDeep = jsonDeep;
		var events_subitem = false;
		try{
			events_subitem = jsonDeep["response_data"][0]["user_items"][0]["user"][0]["events"][0]["events_subitem"];
		}catch(ex){}
		if(events_subitem)
		{
			userManager.methods.rebuildSubItems(userInfo.user.events, "events");
			for(var i=0;i<events_subitem.length;i++)
			{
				var curItem = events_subitem[i];
				if(!curItem.id)
				{
					curItem.id = [{text:userManager.methods.generateRandomPassword(10)}];
					userInfo.user.events.events_subitem[i].id = curItem.id[0].text;
				}
			}
			jsonDeep["response_data"][0]["user_items"][0]["user"][0]["events"][0]["events_subitem"] = events_subitem;
			panelEvents.jsonDeep = jsonDeep;
		}

		var options = {
			  rootTagName: 'events'
		};
		if(userInfo.user && userInfo.user.events && userInfo.user.events.events_subitem)
		{
			var xml = $.json2xml(userInfo.user.events.events_subitem, options);
			var events = false;
			try{
				events = panelEvents.jsonDeep["response_data"][0]["user_items"][0]["user"][0]["events"];
			}catch(ex){}
			if(!events || !jQuery.isArray(events))
			{
				panelEvents.jsonDeep["response_data"][0]["user_items"][0]["user"][0]["events"] = [$.xml2json(xml, true)];
			}
		}
	}

	var dataPanel = panel || panelEvents._panel;
	panelEvents.clearForm(dataPanel);
	var ftpDirPanel = $("#ftpDirPanel", panelEvents._panel).hide();

	if(panel)
	{
		panel.removeClass("inheritValSet");
	}
	if(userInfo.user)
	{
		userManager.data.bindValuesFromJson(dataPanel, userInfo.user, false, panel);
	}
	//Binding event list
	var eventList = $("#eventList", dataPanel).empty();
	userManager.UI.multiOptionControlDataBind(userInfo.user
		, "events"
		, eventList
		, function addNewButton(curItem){
			if(curItem && curItem.name)
			{
				var name = curItem.name;
				return $("<li class='ui-widget-content'>"+decodeURIComponent(unescape(name))+"</li>");
			}
			else
				return false;
		}
	, !panel);

	eventList.find("li").each(function(){
		var json = false;
		try{
			json = jsonDeep["response_data"][0]["user_items"][0]["user"][0]["events"][0]["events_subitem"][$(this).index()];
		}catch(ex){}
		$(this).data("pluginData", json);
	});

	//Bind available plugins
	var availablePlugins = $(document).data("GUIXMLPrefs").plugins.plugins_subitem;
	userManager.methods.rebuildSubItems(availablePlugins, "plugins_subitem");

	var pluginsAvailable = $("#pluginsAvailable", dataPanel);
	var addedPlugins = [];
	function addPluginName(item)
	{
		if(jQuery.isArray(item) && item.length>0)
		{
			for(var i=0;i<item.length;i++)
			{
				addPluginName(item[i]);
			}
		}
		else
		{
			var pluginName = item.pluginName;
			if(!addedPlugins.has(pluginName))
			{
				addedPlugins.push(pluginName);
				var optionItem = $("<option value='"+item.pluginName+"'>"+pluginName+" (User Defined)</option>");
				pluginsAvailable.append(optionItem);
				optionItem.data("pluginDetails", item);
			}

			if(item.subItem && item.subItem.length > 0)
			{
				pluginName = pluginName + ":" + item.subItem;
			}
			if(pluginName && pluginName.length > 0)
			{
				var optionItem = $("<option value='"+pluginName+"'>"+pluginName+"</option>");
				pluginsAvailable.append(optionItem);
				optionItem.data("pluginDetails", item);
			}
		}
	}

	if(availablePlugins)
	{
		for(var i=0;i<availablePlugins.length;i++)
		{
			addPluginName(availablePlugins[i].plugins_subitem_subitem);
		}
	}

	if(!panel)
	{
		$("#userEvents", dataPanel).closest("fieldset").removeClass("inheritSet");
		userManager.data.setInheritPropertyOfSection($("#userEvents", dataPanel), "events", true);
	}
	userManager.UI.panelsPostbindEvent(dataPanel, panel);
	userManager.UI.togglePanels(panelEvents._panel);
	if($("#event_if_cb", panelEvents._panel).is(":checked") && $("#event_if_list", panelEvents._panel).val()!="")
	{
		ftpDirPanel.show();
	}
}

panelEvents.loadEventInfo = function(eventVal, loadedFromDD)
{
	var pluginsAvailable = $("#pluginsAvailable", panelEvents._panel);
	$("#emailActionPanel, #pluginActionPanel", panelEvents._panel).hide();
	if(eventVal == "(send_email)")
	{
		$("#emailActionPanel", panelEvents._panel).show();
		panelEvents.eventDataChanged();
	}
	else if(eventVal == "(run_plugin)")
	{
		var pluginActionPanel = $("#pluginActionPanel", panelEvents._panel).show();
		window.embedPlugin = true;
		var jsonDeep = panelEvents.jsonDeep;
		var pluginToLoad = $("#pluginName", panelEvents._panel).val();
		var event_plugin_list = unescape($("#event_plugin_list", panelEvents._panel).val());
		if(event_plugin_list && event_plugin_list.lastIndexOf(":") == event_plugin_list.length-1)
		{
			event_plugin_list = event_plugin_list.substring(0, event_plugin_list.lastIndexOf(":"));
		}
		if(!event_plugin_list || event_plugin_list == "undefined" || typeof event_plugin_list == "undefined" || event_plugin_list.length == 0)
		{
			event_plugin_list = "CrushTask (User Defined)";
		}
		pluginsAvailable.find("option").each(function() { this.selected = (this.text == event_plugin_list); });
		pluginPlaceHolder.show();
		var loadPlugin = true;
		if(event_plugin_list.indexOf("(User Defined)")<0)
		{
			loadPlugin = false;
			pluginPlaceHolder.hide();
		}
		if(!pluginToLoad || pluginToLoad.length==0)
		{
			pluginToLoad = pluginsAvailable.val();
		}

		try{
			var eventList = $("#eventList", panelEvents._panel);
			var selected = $("li.ui-widget-header", eventList);
			var index = selected.index();
			var pluginData = selected.data("pluginData");
			//if(!pluginData && !loadedFromDD) return;
			if(pluginData)
			{
				var pluginName = "";
				if(pluginData.pluginName && pluginData.pluginName.length)
				{
					pluginName = pluginData.pluginName[0].text;
				}
				else
				{
					pluginName = $("#pluginName", panelEvents._panel).val();
					pluginData.pluginName = [{text:pluginName}];
				}
				if(pluginName != $("#pluginsAvailable", panelEvents._panel).val() && loadedFromDD)
				{
					pluginData = false;
				}
			}
			if(loadPlugin)
			{
				$.getScript("/WebInterface/Preferences/js/crushftp.localizations.js", function() {
					$.getScript("/WebInterface/Preferences/js/crushftp.interface.js", function() {
						window.decodeFirst = true;
						loadPanel("Plugins", true, {
							loadPlugin : pluginToLoad,
							pluginID : userManager.methods.generateRandomPassword(10),
							returnXML : true,
							placeHolder : pluginPlaceHolder,
							dataItem : pluginData,
							baseUrl : "/WebInterface/Preferences/",
							hideButtons : true,
							ignoreChanges : true
						});
					});
				});
			}
		}
		catch(ex)
		{
			if(ex && ex.toString() != "")
			{
				userManager.UI.growl("Error", ex, true);
			}
		}
	}
	var ftpDirPanel = $("#ftpDirPanel", panelEvents._panel);
	if($("#event_if_cb", panelEvents._panel).is(":checked") && $("#event_if_list", panelEvents._panel).val()!="")
	{
		ftpDirPanel.show();
	}

	$("#event_if_list", panelEvents._panel).unbind().change(function(){
		if($(this).val()!="")
			userManager.UI.checkUnchekInput($("#event_if_cb", panelEvents._panel), true);
		if($(this).val().lastIndexOf("_dir")>=0)
		{
			ftpDirPanel.show();
		}
		else
		{
			ftpDirPanel.hide();
		}
	}).trigger("change");

	$("#event_after_list", panelEvents._panel).unbind().change(function(){
		if($(this).val()!="")
			userManager.UI.checkUnchekInput($("#event_after_cb", panelEvents._panel), true);
	});
}

panelEvents.updatePluginControlData = function(pluginName, fromPlugin)
{
	panelEvents.eventDataChanged();
}

panelEvents.rebuildEventListFromLocalData = function(curUser, hidePanels, eventData, isAddedNew)
{
	if(hidePanels){
		$("#eventActionPanel", panelEvents._panel).hide();
	}
	eventList.empty();
	userManager.UI.multiOptionControlDataBind(curUser
		, "events"
		, eventList
		, function addNewButton(curItem){
			if(curItem && curItem.name)
			{
				var name = curItem.name;
				return $("<li class='ui-widget-content'>"+decodeURIComponent(unescape(name))+"</li>");
			}
			else
			{
				return false;
			}
		}
	, !isAddedNew);

	eventList.find("li").each(function(){
		var events = panelEvents.jsonDeep["response_data"][0]["user_items"][0]["user"][0]["events"];
		var json = false;
		if(events && events.length >0)
		{
			events = events[0];
			json = events["events_subitem"][$(this).index()];
		}
		if(json)
			$(this).data("pluginData", json);
		else if(eventData)
			$(this).data("pluginData", eventData);
	});

	if(isAddedNew)
	{
		eventList.find("li:last").addClass("ui-selected ui-widget-header");
		panelEvents.eventItemSelected(eventList, eventList.find("li:last"));
	}
}

panelEvents.bindEvents = function()
{
	userManager.UI.togglePanels(panelEvents._panel);

	$("#showNotSupportedPluginList", panelEvents._panel).click(function(){
		var listOfPluginsInSystem = $("#listOfPluginsInSystem", panelEvents._panel);
		if(listOfPluginsInSystem.is(":hidden"))
		{
			listOfPluginsInSystem.show();
			$(this).text("Hide list");
		}
		else
		{
			listOfPluginsInSystem.hide();
			$(this).text("Show list of plugins");
		}
		return false;
	});

	$(".checkboxArea>input[type='checkbox']", panelEvents._panel).change(function(){
		var curUserData = userManager.storage("currentUserInherited");
		if(!$(this).is(":checked"))
		{
			curUserData = {user: userManager.storage("currentUsersLowerLevelsData")};
			$(this).closest("fieldset").addClass("inheritSet");
		}
		else
			$(this).closest("fieldset").removeClass("inheritSet");

		if(!$(this).closest("fieldset").hasClass("notInheritable"))
		{
			$("#eventActionPanel", panelEvents._panel).hide();
			panelEvents.bindData(curUserData, panelEvents.jsonDeep, $(this).closest("fieldset"), false);
		}
	});
	//hide eventActionPanel, show it on selection
	$("#eventActionPanel", panelEvents._panel).hide();
	var ftpDirPanel = $("#ftpDirPanel", panelEvents._panel);

	var pluginsAvailable = $("#pluginsAvailable", panelEvents._panel).unbind("change").change(function(){
		var selectedName = $(this).find("option:selected").text();
		var pluginName = $(this).val().split(":")[0];
		$("#pluginName", panelEvents._panel).val(pluginName);
		$("#event_plugin_list", panelEvents._panel).val(selectedName).trigger("change");
		panelEvents.loadEventInfo(event_action_list.val(), true);
	});

	event_action_list.unbind("change").change(function(){
		panelEvents.loadEventInfo($(this).val(), true);
	});

	eventList.unbind("onSelect").bind("onSelect"
		, function(evt, list, selected){
			panelEvents.eventItemSelected(list, selected);
	});

	function addNewEventToCollection(newEvent, defaultData, isLink)
	{
		var events = [];
		var currentUserInherited = userManager.storage("currentUserInherited");
		if(currentUserInherited && currentUserInherited.user)
		{
			currentUserInherited = currentUserInherited.user;
			if(currentUserInherited && currentUserInherited.events)
			{
				events = currentUserInherited.events;
			}
			else
			{
				currentUserInherited.events = events;
			}
			userManager.methods.rebuildSubItems(events, "events");
			events.events_subitem.push(newEvent);
		}

		var events = panelEvents.jsonDeep["response_data"][0]["user_items"][0]["user"][0]["events"];
		if(!events || !jQuery.isArray(events))
		{
			panelEvents.jsonDeep["response_data"][0]["user_items"][0]["user"][0]["events"] = [{
				"events_subitem" : []
			}];
		}
		else if(!events[0]["events_subitem"] || !jQuery.isArray(events[0]["events_subitem"]))
		{
			events[0]["events_subitem"] = [];
		}
		var eventsAll = panelEvents.jsonDeep["response_data"][0]["user_items"][0]["user"][0]["events"][0]["events_subitem"];
		if(isLink)
			eventsAll.push(defaultData);
		panelEvents.rebuildEventListFromLocalData(currentUserInherited, false, defaultData, true);
		panelEvents._panel.trigger("changed");
	}

	$("#addEvent", panelEvents._panel).unbind().click(function(){
		jPrompt("Please enter name for this event :", "", "CrushFTP Events", function(value){
			if(value)
			{
				if(userManager.methods.hasSpecialCharacters(value, userManager.notAllowedCharsInDirName))
				{
					jAlert("You can not use these characters in name : \"" + userManager.notAllowedCharsInDirName + "\"", "Message", function(){
						$("#addEvent", panelEvents._panel).trigger("click");
					});
					return false;
				}
				var uId = userManager.methods.generateRandomPassword(10);
				addNewEventToCollection({
						command: "EMAIL",
						event_action_list : "(send_email)",
						event_dir_data: "",
						from: "%user_email%",
						id: uId,
						name: value,
						subject: "Example for on Disconnect:?User %user_name%",
						event_always_cb : "true",
						event_after_cb : "true",
						event_after_list : "(disconnect_all)"
				}, {
						command: [{text : "EMAIL"}],
						event_action_list : [{text : "(send_email)"}],
						event_dir_data: [{text : ""}],
						from: [{text : "%user_email%"}],
						id: [{text : uId}],
						name: [{text : value}],
						subject: [{text : "Example for on Disconnect:?User %user_name%"}],
						event_always_cb : [{text : "true"}],
						event_after_cb : [{text : "true"}],
						event_after_list : [{text : "(disconnect_all)"}]
				});
			}
		});
		return false;
	});

	$("#deleteEvent", panelEvents._panel).unbind().click(function(){
		var selected = eventList.find("li.ui-selected");
		if(selected && selected.length>0)
		{
			var eventName = selected.text();
			jConfirm("Are you sure you want to delete event '" + eventName + "' ?", "CrushFTP Events", function(value){
				if(value)
				{
					var indexOfEvent = selected.index();
					var eventsItem = panelEvents.jsonDeep["response_data"][0]["user_items"][0]["user"][0]["events"][0]["events_subitem"];
					eventsItem.remove(indexOfEvent);

					var events = [];
					var currentUserInherited = userManager.storage("currentUserInherited");
					if(currentUserInherited && currentUserInherited.user)
					{
						currentUserInherited = currentUserInherited.user;
						if(currentUserInherited && currentUserInherited.events)
						{
							events = currentUserInherited.events;
						}
						else
						{
							currentUserInherited.events = events;
						}
						userManager.methods.rebuildSubItems(events, "events");
						for(var i=0;i<events.events_subitem.length;i++)
						{
							if(events.events_subitem[i].name == eventName)
							{
								events.events_subitem.remove(i);
								i = events.events_subitem.length+1;
							}
						}
						$("#eventActionPanel", panelEvents._panel).hide();
						panelEvents.rebuildEventListFromLocalData(currentUserInherited, true);
						var lastItemInList = eventList.find("li:last");
						if(lastItemInList.length>0)
						{
							lastItemInList.addClass("ui-selected ui-widget-header");
							panelEvents.eventItemSelected(eventList, lastItemInList);
						}
						else
						{
							$("#eventActionPanel", panelEvents._panel).hide();
						}
					}
					panelEvents._panel.trigger("changed");
				}
			});
		}
		return false;
	});

	$("#renameEvent", panelEvents._panel).unbind().click(function(){
		var renameEventBtn = $(this);
		var selected = eventList.find("li.ui-selected");
		if(selected && selected.length>0)
		{
			var eventName = selected.text();
			jPrompt("Please enter name for this event :", eventName, "CrushFTP Events", function(value){
				if(value)
				{
					if(userManager.methods.hasSpecialCharacters(value, userManager.notAllowedCharsInDirName))
					{
						jAlert("You can not use these characters in name : \"" + userManager.notAllowedCharsInDirName + "\"", "Message", function(){
							$("#renameEvent", panelEvents._panel).trigger("click");
						});
						return false;
					}
					var indexOfEvent = selected.index();
					var eventsItem = panelEvents.jsonDeep["response_data"][0]["user_items"][0]["user"][0]["events"][0]["events_subitem"];
					eventsItem[indexOfEvent].name[0].text = value;
					$("#name", panelEvents._panel).val(value);
					var currentUserInherited = panelEvents.jsonDeep["response_data"][0]["user_items"][0]["user"][0];
					var events = [];
					var currentUserInherited = userManager.storage("currentUserInherited");
					if(currentUserInherited && currentUserInherited.user)
					{
						currentUserInherited = currentUserInherited.user;
						if(currentUserInherited && currentUserInherited.events)
						{
							events = currentUserInherited.events;
						}
						else
						{
							currentUserInherited.events = events;
						}
						userManager.methods.rebuildSubItems(events, "events");
						events.events_subitem[selected.index()].name = value;
					}
					panelEvents.rebuildEventListFromLocalData(currentUserInherited);
					eventList.find("li:eq("+indexOfEvent+")").addClass("ui-selected ui-widget-header");
					panelEvents._panel.trigger("changed");
				}
			});
		}
		return false;
	});

	$("#duplicateEvent", panelEvents._panel).unbind().click(function(){
		var selected = eventList.find("li.ui-selected");
		if(selected && selected.length>0)
		{
			var eventName = selected.text();
			jPrompt("Please enter name for this event :", "Copy of " + eventName, "CrushFTP Events", function(value){
				if(value)
				{
					var events = [];
					var currentUserInherited = userManager.storage("currentUserInherited");
					if(currentUserInherited && currentUserInherited.user)
					{
						currentUserInherited = currentUserInherited.user;
						if(currentUserInherited && currentUserInherited.events)
						{
							events = currentUserInherited.events;
						}
						else
						{
							currentUserInherited.events = events;
						}

						userManager.methods.rebuildSubItems(events, "events");

						for(var i=0;i<events.events_subitem.length;i++)
						{
							if(events.events_subitem[i].name == eventName)
							{
								var copy = $.extend(true, {}, events.events_subitem[i]);
								copy.name = value;
								events.events_subitem.push(copy);
								i = events.events_subitem.length+1;
							}
						}
						var copyFrom = panelEvents.jsonDeep["response_data"][0]["user_items"][0]["user"][0]["events"][0]["events_subitem"][selected.index()];
						var data = $.extend({}, copyFrom);
						//data.name = [{text: value}];
						data.id = [{text: userManager.methods.generateRandomPassword(10)}];
						panelEvents.jsonDeep["response_data"][0]["user_items"][0]["user"][0]["events"][0]["events_subitem"].push(data);
						panelEvents.rebuildEventListFromLocalData(currentUserInherited, true);
						eventList.find("li:last").addClass("ui-selected ui-widget-header");
						panelEvents.eventItemSelected(eventList, eventList.find("li:last"));
					}
					panelEvents._panel.trigger("changed");
				}
			});
		}
		return false;
	});

	$("#linkEvent, #copyEvent", panelEvents._panel).unbind().click(function(){
		var isCopy = $(this).is("#copyEvent");
		var userList = userManager.storage("users");
		var currentUser = userManager.storage("userName");
		var users = [];
		for(var i=0; i<userList.length;i++)
		{
			var name = userList[i].text;
			if(name && name.toLowerCase() != currentUser.toLowerCase())
			{
				users.push(userList[i].text);
			}
		}
		if(users.length>0)
		{
			var action = isCopy ? "copy" : "link";
			jPrompt("Pick another CrushFTP user to "+action+" event from :", "", "Pick A User", function(selectedUser){
				if(selectedUser)
				{
					userManager.dataRepo.getUserInfo(selectedUser, function(info, xml){
						var eventsAvailable = false;
						if(info && info.user && info.user.events)
						{
							var events = info.user.events;
							if(events && events.events_subitem)
							{
								userManager.methods.rebuildSubItems(events, "events");
								events = events.events_subitem;

								if(events.length>0)
								{
									eventsAvailable = true;
									var selectedUserEvents = [];
									for(var i=0;i<events.length;i++)
									{
										selectedUserEvents.push(events[i].name);
									}
									if(selectedUserEvents.length>0)
									{
										jPrompt("Pick the event item to "+action+" :", "", "Pick Event", function(value){
											if(value)
											{
												var selectedEvent = {};
												var selectedIndex = -1;
												for(var i=0;i<events.length;i++)
												{
													if(events[i].name == value)
													{
														selectedEvent = events[i];
														selectedIndex = i;
														i = events.length + 1;
													}
												}
												if(selectedEvent && selectedEvent.name)
												{
													if(!isCopy)
													{
														selectedEvent.name = "LINK : " + selectedUser + " : " + selectedEvent.name;
													}
													var deepJsonForEvent = $.xml2json(xml, true);
													try{
														deepJsonForEvent = deepJsonForEvent["response_data"][0]["user_items"][0]["user"][0]["events"][0]["events_subitem"][selectedIndex];
													}catch(ex){}
													if(deepJsonForEvent && deepJsonForEvent.name)
													{
														deepJsonForEvent.name = [{text:selectedEvent.name}];
														if(isCopy)
															deepJsonForEvent.id = [{text: userManager.methods.generateRandomPassword(10)}];
													}
													addNewEventToCollection(selectedEvent, deepJsonForEvent, !isCopy);
												}
											}
										}, selectedUserEvents);
									}
								}
							}
						}
						if(!eventsAvailable)
						{
							jAlert("No events available for selected user : '" + selectedUser + "'", "Message");
						}
					}, false, true);
					panelEvents._panel.trigger("changed");
				}
			}, users);
		}
		return false;
	});

	$("a#sendEventEmail", panelEvents._panel).click(function(){
		var link = $(this);
		if(link.attr("disabled")) return false;

		var obj = {
			command : "sendEventEmail",
			email_from : userManager.methods.htmlEncode($("#from", panelEvents._panel).val()),
			email_to : userManager.methods.htmlEncode($("#to", panelEvents._panel).val()),
			email_cc : userManager.methods.htmlEncode($("#cc", panelEvents._panel).val()),
			email_bcc : userManager.methods.htmlEncode($("#bcc", panelEvents._panel).val()),
			email_subject : userManager.methods.htmlEncode($("#subject", panelEvents._panel).val()),
			email_body : userManager.methods.htmlEncode($("#body", panelEvents._panel).val())
		};
		if($("#email", panelSetup._panel).val().length>0)
		{
			obj.user_email = userManager.methods.htmlEncode($("#email", panelSetup._panel).val());
		}
		userManager.methods.performServerAction(link
			, obj
			, "Sending user information via email :");

		return false;
	});
}

panelEvents.eventDataChanged = function()
{
	var eventList = $("#eventList", panelEvents._panel);
	var eventActionPanel = $("#eventActionPanel", panelEvents._panel);
	var selected = eventList.find("li.ui-selected");
	if(selected) // If event is selected
	{
		var pluginData = selected.data("pluginData");
		var isPlugin = event_action_list.val() == "(run_plugin)";
		var eventsJsonData = {};
		var eventsJsonDataDeep = {};
		if(isPlugin && pluginData && pluginData.pluginName && jQuery.isArray(pluginData.pluginName))
		{
			var pluginName = pluginData.pluginName[0].text;
			if(pluginName && pluginName.length>0 &&  window["plugin"+pluginName])
			{
				var script = "selected.data(\"pluginDataTemp\", plugin"+pluginName+".saveContent());";
				eval(script);
				var eventPluginData = selected.data("pluginDataTemp");
				selected.removeData("pluginDataTemp");
				eventsJsonDataDeep = $.xml2json(eventPluginData, true);
				eventsJsonData = $.xml2json(eventPluginData);
			}
		}
		var eventDataBindPanel  = eventActionPanel.find("#eventDataBindPanel");
		var inputs = eventDataBindPanel.find(".ignoreBind").removeClass("ignoreBind");
		$("#pluginsAvailable, #variable", panelEvents._panel).addClass("ignoreBind");
		var xml = userManager.data.buildXMLToSubmitForm(eventDataBindPanel, true);
		inputs.addClass("ignoreBind");
		var fieldsData = $.xml2json("<item>"+xml+"</item>");
		var mergedData = $.extend(fieldsData, eventsJsonData);
		selected.data("controlData", mergedData);
		var fieldsDataDeep = $.xml2json("<item>"+xml+"</item>", true);
		var mergedDataDeep = $.extend(fieldsDataDeep, eventsJsonDataDeep);
		mergedDataDeep = userManager.methods.jsonToXML(mergedDataDeep, false, true);
		mergedDataDeep = $.xml2json("<item>"+mergedDataDeep+"</item>", true);
		panelEvents.updateEventsDataInCache(mergedDataDeep);
	}
}

panelEvents.updateEventsDataInCache = function(eventData)
{
	var eventsItem = panelEvents.jsonDeep["response_data"][0]["user_items"][0]["user"][0]["events"][0]["events_subitem"];
	if(!eventsItem)
	{
		var events = panelEvents.jsonDeep["response_data"][0]["user_items"][0]["user"][0]["events"];
		if(!events || !jQuery.isArray(events))
		{
			panelEvents.jsonDeep["response_data"][0]["user_items"][0]["user"][0]["events"] = [{
				"events_subitem" : []
			}];
		}
		else if(!events[0]["events_subitem"] || !jQuery.isArray(events[0]["events_subitem"]))
		{
			events[0]["events_subitem"] = [];
		}
		eventsItem = panelEvents.jsonDeep["response_data"][0]["user_items"][0]["user"][0]["events"][0]["events_subitem"];
	}
	var eventFound = false;
	var ID = eventData.id[0].text;
	for(var i=0;i<eventsItem.length;i++)
	{
		var curEvent = eventsItem[i];
		var eventId = curEvent.id[0].text;

		if(ID == eventId)
		{
			eventsItem[i] = $.extend({}, eventData);
			eventFound = true;
		}
	}
	if(!eventFound)
	{
		if(!jQuery.isArray(eventsItem))
		{
			eventsItem = [];
		}
		eventsItem.push(eventData);
	}
	var selected = eventList.find("li.ui-selected");
	if(selected && selected.length>0)
		selected.data("pluginData", eventData);
}

panelEvents.eventItemSelected = function(list, selected)
{
	var eventList = $("#eventList", panelEvents._panel);
	var eventActionPanel = $("#eventActionPanel", panelEvents._panel);
	if(selected) // If event is selected
	{
		eventActionPanel.show();
		// Options for selected event
		var controlData = selected.data("controlData");
		if(controlData)
		{
			panelEvents._panel.find("#eventDataBindPanel").find("input, select, textarea").unbind("change");
			panelEvents._panel.find("#eventDataBindPanel").find("input[type='text'], textarea").unbind("change");

			var eventDataBindPanel = eventActionPanel.find("#eventDataBindPanel");
			var inputs = eventDataBindPanel.find(".ignoreBind").removeClass("ignoreBind");
			$("#pluginsAvailable, #variable, #event_plugin_list", panelEvents._panel).addClass("ignoreBind");
			userManager.data.bindValuesFromJson(eventDataBindPanel, controlData, false, true);
			$("#pluginName", panelEvents._panel).val(controlData.pluginName || "");
			$("#event_plugin_list", panelEvents._panel).val(unescape(controlData.event_plugin_list) || "");
			var event_plugin_list = unescape($("#event_plugin_list", panelEvents._panel).val());
			if(event_plugin_list && event_plugin_list.lastIndexOf(":") == event_plugin_list.length-1)
			{
				event_plugin_list = event_plugin_list.substring(0, event_plugin_list.lastIndexOf(":"));
			}
			$("#pluginsAvailable", panelEvents._panel).find("option").each(function() { this.selected = (this.text == event_plugin_list); });
			panelEvents.loadEventInfo(event_action_list.val());

			panelEvents._panel.find("#eventDataBindPanel").find("input, select, textarea").bind("change", function(){
				panelEvents.eventDataChanged();
				if($(this).attr("id") == "event_always_cb" && $(this).is(":checked"))
				{
					$("#event_if_list", panelEvents._panel).val("").trigger("change");
				}
				else if($(this).attr("id") == "event_now_cb" && $(this).is(":checked"))
				{
					$("#event_after_list", panelEvents._panel).val("").trigger("change");
				}
			});

			panelEvents._panel.find("#eventDataBindPanel").find("input[type='text'], textarea").bind("textchange", function(){
				panelEvents.eventDataChanged();
			});

			$("#variable", panelEvents._panel).change(function(){
				var selectedText = $(this).find(":selected").text();
				if(selectedText.length>0)
				{
					$("#subject", panelEvents._panel).val();
					var bodyTextArea = $("textarea#body", panelEvents._panel);
					if(bodyTextArea.val().length>0)
					{
						bodyTextArea.val(bodyTextArea.val() + "\n" + ($(this).val()+"").replace(/(\\n)/gm,"\n") + "\n");
					}
					else
					{
						bodyTextArea.val(bodyTextArea.val() + ($(this).val()+"").replace(/(\\n)/gm,"\n") + "\n");
					}
					$(this).val("");
				}
				panelEvents.eventDataChanged();
			});

			event_action_list.unbind("change").change(function(){
				panelEvents.loadEventInfo($(this).val(), true);
			});

			inputs.addClass("ignoreBind");
		}
	}
}

panelEvents.generateXML = function()
{
	if(panelEvents._panel.find("#userEvents").find("input:checked").length>0)
	{
		var xml = ["<events type=\"vector\">"];
		var eventsAvailable = false;
		var eventList = $("#eventList", panelEvents._panel);
		var eventsItem = [];
		try{
			eventsItem = panelEvents.jsonDeep["response_data"][0]["user_items"][0]["user"][0]["events"][0]["events_subitem"];
		}catch(ex){
			eventsItem = false;
		}
		if(eventsItem)
		{
			for(var i=0;i<eventsItem.length;i++)
			{
				var item = userManager.methods.jsonToXML(eventsItem[i], false, true);
				if(item && item.length>0)
				{
					eventsAvailable = true;
					xml.push("<events_subitem type=\"properties\">");
					xml.push(item);
					if(item.indexOf("<id>")<0)
					{
						xml.push("<id>" + userManager.methods.generateRandomPassword(10) + "</id>");
					}
					xml.push("</events_subitem>");
				}
			}
		}
		xml.push("</events>");
		var genXML = "";
		if(eventsAvailable)
		{
			genXML = xml.join("\r\n");
		}
		return genXML;
	}
	else
		return "";
}